Index: /BAORadio/libindi/libindi/libs/indibase/indiccd.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiccd.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indiccd.cpp	(revision 642)
@@ -365,20 +555,9 @@
             GuideEW[0].value=0;
             GuideEW[1].value=0;
-            GuideEWV.s=IPS_OK;
-            IDSetNumber(&GuideEWV,NULL);
-
-            return true;
-        }
-
-        /*
-        if(strcmp(name,"CCDPREVIEW_CTRL")==0) {
-            //  We are being asked to set camera binning
-            GuiderNV.s=IPS_OK;
-            IUUpdateNumber(&GuiderNV,values,names,n);
-            //  Update client display
-            IDSetNumber(&GuiderNV,NULL);
-            return true;
-        }
-        */
+            GuideEWP->s=IPS_OK;
+            IDSetNumber(GuideEWP,NULL);
+
+            return true;
+        }
 
     }
@@ -391,69 +570,53 @@
 {
 
-    //  Ok, lets Process any switches we actually handle here
-    //IDLog("INDI::CCD IsNewSwitch %s %s\n",dev,name);
-
-
-    if(strcmp(dev,deviceName())==0) {
-        //  it's for this device
-
-        //for(int x=0; x<n; x++) {
-        //    IDLog("Switch %s\n",names[x]);
-        //}
-
-        if(strcmp(name,CompressSV.name)==0) {
-
-            IUUpdateSwitch(&CompressSV,states,names,n);
-            IDSetSwitch(&CompressSV,NULL);
-
-            if(CompressS[0].s==ISS_ON    ) {
-                SendCompressed=true;
-            } else {
-                SendCompressed=false;
+    if(strcmp(dev,deviceName())==0)
+    {
+
+
+        if(strcmp(name,PrimaryCCD.CompressSP->name)==0)
+        {
+
+            IUUpdateSwitch(PrimaryCCD.CompressSP,states,names,n);
+            IDSetSwitch(PrimaryCCD.CompressSP,NULL);
+
+            if(PrimaryCCD.CompressS[0].s==ISS_ON    )
+            {
+                PrimaryCCD.SendCompressed=true;
+            } else
+            {
+                PrimaryCCD.SendCompressed=false;
             }
             return true;
         }
-        if(strcmp(name,GuiderCompressSV.name)==0) {
-
-            IUUpdateSwitch(&GuiderCompressSV,states,names,n);
-            IDSetSwitch(&GuiderCompressSV,NULL);
-
-            if(GuiderCompressS[0].s==ISS_ON    ) {
-                SendCompressed=true;
-            } else {
-                SendCompressed=false;
+
+        if(strcmp(name,GuideCCD.CompressSP->name)==0)
+        {
+
+            IUUpdateSwitch(GuideCCD.CompressSP,states,names,n);
+            IDSetSwitch(GuideCCD.CompressSP,NULL);
+
+            if(GuideCCD.CompressS[0].s==ISS_ON    )
+            {
+                GuideCCD.SendCompressed=true;
+            } else
+            {
+                GuideCCD.SendCompressed=false;
             }
             return true;
         }
 
-        if(strcmp(name,GuiderVideoSV.name)==0) {
+        if(strcmp(name,PrimaryCCD.FrameTypeSP->name)==0)
+        {
             //  Compression Update
-            IUUpdateSwitch(&GuiderVideoSV,states,names,n);
-            if(GuiderVideoS[0].s==ISS_ON    ) {
-                GuiderVideoSV.s=IPS_OK;
-                StartGuideExposure(GuiderExposureN[0].value);
-            } else {
-                AbortGuideExposure();
-                GuiderVideoSV.s=IPS_IDLE;
-            }
-
-            IDSetSwitch(&GuiderVideoSV,NULL);
-            return true;
-        }
-
-        if(strcmp(name,FrameTypeSV.name)==0) {
-            //  Compression Update
-            IUUpdateSwitch(&FrameTypeSV,states,names,n);
-            FrameTypeSV.s=IPS_OK;
-            if(FrameTypeS[0].s==ISS_ON) SetFrameType(FRAME_TYPE_LIGHT);
-            if(FrameTypeS[1].s==ISS_ON) SetFrameType(FRAME_TYPE_BIAS);
-            if(FrameTypeS[2].s==ISS_ON) SetFrameType(FRAME_TYPE_DARK);
-            if(FrameTypeS[3].s==ISS_ON) SetFrameType(FRAME_TYPE_FLAT);
-
-
-            IDSetSwitch(&FrameTypeSV,NULL);
-            return true;
-        }
-
+            IUUpdateSwitch(PrimaryCCD.FrameTypeSP,states,names,n);
+            PrimaryCCD.FrameTypeSP->s=IPS_OK;
+            if(PrimaryCCD.FrameTypeS[0].s==ISS_ON) PrimaryCCD.setFrameType(CCDChip::LIGHT_FRAME);
+            if(PrimaryCCD.FrameTypeS[1].s==ISS_ON) PrimaryCCD.setFrameType(CCDChip::BIAS_FRAME);
+            if(PrimaryCCD.FrameTypeS[2].s==ISS_ON) PrimaryCCD.setFrameType(CCDChip::DARK_FRAME);
+            if(PrimaryCCD.FrameTypeS[3].s==ISS_ON) PrimaryCCD.setFrameType(CCDChip::FLAT_FRAME);
+
+            IDSetSwitch(PrimaryCCD.FrameTypeSP,NULL);
+            return true;
+        }
     }
 
@@ -475,4 +638,28 @@
     return -1;
 }
+
+bool INDI::CCD::AbortExposure()
+{
+    IDLog("INDI::CCD::AbortExposure -  Should never get here\n");
+    return false;
+}
+
+bool INDI::CCD::updateCCDFrame(int x, int y, int w, int h)
+{
+    // Nothing to do here. HW layer should take care of it if needed.
+    return false;
+}
+
+bool INDI::CCD::updateCCDBin(int hor, int ver)
+{
+    // Nothing to do here. HW layer should take care of it if needed.
+    return false;
+}
+
+void INDI::CCD::addFITSKeywords(fitsfile *fptr)
+{
+    // Nothing to do here. HW layer should take care of it if needed.
+}
+
 bool INDI::CCD::ExposureComplete()
 {
@@ -482,53 +669,57 @@
     long naxes[2];
     long naxis=2;
+    int numbytes=0;
 
     fitsfile *fptr=NULL;
 
-
     //IDLog("Enter Exposure Complete %d %d %d %d\n",SubW,SubH,BinX,BinY);
 
-
-    naxes[0]=SubW/BinX;
-    naxes[1]=SubH/BinY;
+    naxes[0]=PrimaryCCD.getSubW()/PrimaryCCD.getBinX();
+    naxes[1]=PrimaryCCD.getSubH()/PrimaryCCD.getBinY();
+
+    numbytes = naxes[0] * naxes[1];
+
     //  Now we have to send fits format data to the client
     memsize=5760;
     memptr=malloc(memsize);
-    if(!memptr) {
+    if(!memptr)
+    {
         IDLog("Error: failed to allocate memory: %lu\n",(unsigned long)memsize);
     }
+
     fits_create_memfile(&fptr,&memptr,&memsize,2880,realloc,&status);
-    if(status) {
+
+    if(status)
+    {
 		IDLog("Error: Failed to create FITS image\n");
 		fits_report_error(stderr, status);  /* print out any error messages */
 		return false;
     }
-  	fits_create_img(fptr, USHORT_IMG , naxis, naxes, &status);
-	if (status)
-	{
+
+    fits_create_img(fptr, USHORT_IMG , naxis, naxes, &status);
+
+    if (status)
+    {
 		IDLog("Error: Failed to create FITS image\n");
 		fits_report_error(stderr, status);  /* print out any error messages */
 		return false;
-	}
-
-    fits_write_img(fptr,TUSHORT,1,SubW*SubH/BinX/BinY,RawFrame,&status);
+    }
+
+    addFITSKeywords(fptr);
+
+    fits_write_img(fptr,TUSHORT,1,numbytes,PrimaryCCD.getFrameBuffer(),&status);
+
     if (status)
-	{
+    {
 		IDLog("Error: Failed to write FITS image\n");
 		fits_report_error(stderr, status);  /* print out any error messages */
 		return false;
-	}
-	fits_close_file(fptr,&status);
-	//IDLog("Built the fits file\n");
-
-    //  ok, undo the kludge we threw in for
-    //  guider frames, and set the resolution back
-
-    //ImageFrameN[2].value=SubW;
-    //ImageFrameN[3].value=SubH;
-    //IDSetNumber(&ImageFrameNV,NULL);
-
-
-    ImageExposureNV.s=IPS_OK;
-    IDSetNumber(&ImageExposureNV,NULL);
+    }
+
+    fits_close_file(fptr,&status);
+
+
+    PrimaryCCD.ImageExposureNP->s=IPS_OK;
+    IDSetNumber(PrimaryCCD.ImageExposureNP,NULL);
 
     uploadfile(memptr,memsize);
@@ -539,32 +730,4 @@
 bool INDI::CCD::GuideExposureComplete()
 {
-
-    //IDLog("Enter GuideExposure Complete %d %d\n",GSubW,GSubH);
-
-    if(GuiderVideoS[0].s==ISS_ON) {
-        //  if our stream switch for the guider
-        //  is on, then send this as a video stream
-        //  frame, and, start another frame
-
-        //  Ok, bit of a kludge here
-        //  we need to send a new size to kstars
-        //ImageFrameN[2].value=GSubW;
-        //ImageFrameN[3].value=GSubH;
-        //IDSetNumber(&ImageFrameNV,NULL);
-
-        //IDLog("Sending guider stream blob\n");
-
-        GuiderExposureNV.s=IPS_OK;
-        IDSetNumber(&GuiderExposureNV,NULL);
-        GuiderB.blob=RawGuiderFrame;
-        GuiderB.bloblen=GSubW*GSubH;
-        GuiderB.size=GSubW*GSubH;
-        strcpy(GuiderB.format,".stream");
-        GuiderBV.s=IPS_OK;
-        IDSetBLOB(&GuiderBV,NULL);
-        StartGuideExposure(GuiderExposureN[0].value);
-    } else {
-        //  We are not streaming
-        //  So, lets send this as an 8 bit fits frame
         void *memptr;
         size_t memsize;
@@ -574,14 +737,16 @@
 
         fitsfile *fptr=NULL;
-        naxes[0]=GSubW;
-        naxes[1]=GSubH;
+        naxes[0]=GuideCCD.getSubW();
+        naxes[1]=GuideCCD.getSubH();
         //  Now we have to send fits format data to the client
         memsize=5760;
         memptr=malloc(memsize);
-        if(!memptr) {
+        if(!memptr)
+        {
             IDLog("Error: failed to allocate memory: %lu\n",(unsigned long)memsize);
         }
         fits_create_memfile(&fptr,&memptr,&memsize,2880,realloc,&status);
-        if(status) {
+        if(status)
+        {
             IDLog("Error: Failed to create FITS image\n");
             fits_report_error(stderr, status);  /* print out any error messages */
@@ -596,5 +761,5 @@
         }
 
-        fits_write_img(fptr,TBYTE,1,GSubW*GSubH,RawGuiderFrame,&status);
+        fits_write_img(fptr,TBYTE,1,naxes[0]*naxes[1],GuideCCD.getFrameBuffer(),&status);
         if (status)
         {
@@ -605,17 +770,15 @@
         fits_close_file(fptr,&status);
         IDLog("Built the Guider fits file\n");
-        GuiderExposureNV.s=IPS_OK;
-        IDSetNumber(&GuiderExposureNV,NULL);
-
-        IDLog("Sending guider fits file via %s\n",GuiderBV.name);
-        GuiderB.blob=memptr;
-        GuiderB.bloblen=memsize;
-        GuiderB.size=memsize;
-        strcpy(GuiderB.format,".fits");
-        GuiderBV.s=IPS_OK;
-        IDSetBLOB(&GuiderBV,NULL);
+        GuideCCD.ImageExposureNP->s=IPS_OK;
+        IDSetNumber(GuideCCD.ImageExposureNP,NULL);
+
+        IDLog("Sending guider fits file via %s\n",GuideCCD.FitsBP->name);
+        GuideCCD.FitsB.blob=memptr;
+        GuideCCD.FitsB.bloblen=memsize;
+        GuideCCD.FitsB.size=memsize;
+        strcpy(GuideCCD.FitsB.format,".fits");
+        GuideCCD.FitsBP->s=IPS_OK;
+        IDSetBLOB(GuideCCD.FitsBP,NULL);
         free(memptr);
-    }
-
 
     return true;
@@ -623,108 +786,38 @@
 
 
-int INDI::CCD::sendPreview()
-{
-    int numbytes;
-    int xw;
-    int yw;
-    //unsigned char *compressed;
-    //uLongf compressedbytes=0;
-    //int ccount;
-    //int r;
+int INDI::CCD::uploadfile(void *fitsdata,int total)
+{
+    //  lets try sending a ccd preview
+    //IDLog("Enter Uploadfile with %d total sending via %s\n",total,FitsBP->name);
+    PrimaryCCD.FitsB.blob=fitsdata;
+    PrimaryCCD.FitsB.bloblen=total;
+    PrimaryCCD.FitsB.size=total;
+    strcpy(PrimaryCCD.FitsB.format,".fits");
+    PrimaryCCD.FitsBP->s=IPS_OK;
+    IDSetBLOB(PrimaryCCD.FitsBP,NULL);
 
     return 0;
-    xw=SubW/BinX;
-    yw=SubH/BinY;
-
-    //GuiderNV.s=IPS_OK;
-    //GuiderN[0].value=xw;
-    //GuiderN[1].value=yw;
-    //IDLog("Guider Frame %d x %d\n",xw,yw);
-    //IDSetNumber(&GuiderNV,"Starting to send new preview frame\n");
-
-    numbytes=xw*yw;
-    numbytes=numbytes*2;
-    //compressedbytes=numbytes+numbytes/64+16+3;
-    //compressed=(unsigned char *)malloc(numbytes+numbytes/64+16+3);
-    //r=compress2(compressed,&compressedbytes,(unsigned char *)RawFrame,numbytes,9);
-    //if(r != Z_OK) {
-    //    IDLog("Got an error from compress\n");
-    //    return -1;
-    //}
-
-
-    //FitsB.blob=compressed;
-    //FitsB.bloblen=compressedbytes;
-    FitsB.blob=RawFrame;
-    FitsB.bloblen=numbytes;
-    FitsB.size=numbytes;
-    FitsBV.s=IPS_OK;
-    strcpy(FitsB.format,".ccdpreview");
-    IDSetBLOB(&FitsBV,NULL);
-    //IDLog("Done with SetBlob with %d compressed to %d\n",numbytes,compressedbytes);
-    //free(compressed);
-    return 0;
-
-}
-
-int INDI::CCD::uploadfile(void *fitsdata,int total)
-{
-    //  lets try sending a ccd preview
-
-
-    //IDLog("Enter Uploadfile with %d total sending via %s\n",total,FitsBV.name);
-    FitsB.blob=fitsdata;
-    FitsB.bloblen=total;
-    FitsB.size=total;
-    strcpy(FitsB.format,".fits");
-    FitsBV.s=IPS_OK;
-    IDSetBLOB(&FitsBV,NULL);
-    //IDLog("Done with SetBlob\n");
-
-    return 0;
-}
-
-int INDI::CCD::SetCCDParams(int x,int y,int bpp,float xf,float yf)
-{
-    XRes=x;
-    YRes=y;
-    SubX=0;
-    SubY=0;
-    SubW=XRes;
-    SubH=YRes;
-    BinX=1;
-    BinY=1;
-
-    PixelSizex=xf;
-    PixelSizey=yf;
-    ImageFrameN[2].value=x;
-    ImageFrameN[3].value=y;
-    ImagePixelSizeN[0].value=x;
-    ImagePixelSizeN[1].value=y;
-    ImagePixelSizeN[2].value=xf;
-    ImagePixelSizeN[3].value=xf;
-    ImagePixelSizeN[4].value=yf;
-    ImagePixelSizeN[5].value=bpp;
-    return 0;
-}
-
-int INDI::CCD::SetGuidHeadParams(int x,int y,int bpp,float xf,float yf)
+}
+
+void INDI::CCD::SetCCDParams(int x,int y,int bpp,float xf,float yf)
+{
+    PrimaryCCD.setResolutoin(x, y);
+    PrimaryCCD.setFrame(0, 0, x, y);
+    PrimaryCCD.setBin(1,1);
+    PrimaryCCD.setPixelSize(xf, yf);
+    PrimaryCCD.setBPP(bpp/8);
+
+}
+
+void INDI::CCD::SetGuidHeadParams(int x,int y,int bpp,float xf,float yf)
 {
     HasGuideHead=true;
-    GXRes=x;
-    GYRes=y;
-    GSubX=0;
-    GSubY=0;
-    GSubW=GXRes;
-    GSubH=GYRes;
-    GuiderFrameN[2].value=x;
-    GuiderFrameN[3].value=y;
-    GuiderPixelSizeN[0].value=x;
-    GuiderPixelSizeN[1].value=y;
-    GuiderPixelSizeN[2].value=xf;
-    GuiderPixelSizeN[3].value=xf;
-    GuiderPixelSizeN[4].value=yf;
-    GuiderPixelSizeN[5].value=bpp;
-    return 0;
+
+    GuideCCD.setResolutoin(x, y);
+    GuideCCD.setFrame(0, 0, x, y);
+    GuideCCD.setBin(1,1);
+    GuideCCD.setPixelSize(xf, yf);
+    GuideCCD.setBPP(bpp/8);
+
 }
 
@@ -734,24 +827,20 @@
 }
 
-int INDI::CCD::GuideNorth(float)
-{
-    return -1;
-}
-int INDI::CCD::GuideSouth(float)
-{
-    return -1;
-}
-int INDI::CCD::GuideEast(float)
-{
-    return -1;
-}
-int INDI::CCD::GuideWest(float)
-{
-    return -1;
-}
-int INDI::CCD::SetFrameType(int t)
-{
-    //fprintf(stderr,"Set frame type to %d\n",t);
-    FrameType=t;
-    return 0;
-}
+
+bool INDI::CCD::GuideNorth(float ms)
+{
+    return false;
+}
+bool INDI::CCD::GuideSouth(float ms)
+{
+    return false;
+}
+bool INDI::CCD::GuideEast(float ms)
+{
+    return false;
+}
+bool INDI::CCD::GuideWest(float ms)
+{
+    return false;
+}
+
Index: /BAORadio/libindi/libindi/libs/indibase/indiccd.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiccd.h	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indiccd.h	(revision 642)
@@ -1,163 +1,262 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
-
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
-
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
-
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+  Copyright(c) 2010, 2011 Gerry Rozema, Jasem Mutlaq. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
+
 
 #ifndef INDI_CCD_H
 #define INDI_CCD_H
 
+#include <fitsio.h>
+
 #include "defaultdriver.h"
-
-#define FRAME_TYPE_LIGHT 0
-#define FRAME_TYPE_BIAS 1
-#define FRAME_TYPE_DARK 2
-#define FRAME_TYPE_FLAT 3
-
-class INDI::CCD : public INDI::DefaultDriver
+#include "indiguiderinterface.h"
+
+extern const char *IMAGE_SETTINGS_TAB;
+extern const char *IMAGE_INFO_TAB;
+extern const char *GUIDE_HEAD_TAB;
+extern const char *GUIDE_CONTROL_TAB;
+
+class CCDChip
 {
-    protected:
-
-        char *RawFrame;
-        int RawFrameSize;
-
-        //  Altho these numbers are indeed stored in the indi properties
-        //  It makes for much cleaner code if we have 'plain old number' copies
-        //  So, when we process messages, just update both
-
-        int XRes;   //  native resolution of the ccd
-        int YRes;   //  ditto
-        int SubX;   //  left side of the subframe we are requesting
-        int SubY;   //  top of the subframe requested
-        int SubW;   //  width of the subframe
-        int SubH;   //  height of the subframe
-        int BinX;   //  Binning requested in the x direction
-        int BinY;   //  Binning requested in the Y direction
-        float PixelSizex;   //  pixel size in microns, x direction
-        float PixelSizey;   //  pixel size in microns, y direction
-        bool SendCompressed;
-
-        bool HasSt4Port;
-
-        //  If the camera has a second ccd, or integrated guide head
-        //  we need information on that one too
-        bool HasGuideHead;
-        char *RawGuiderFrame;
-        int RawGuideSize;
-        int GXRes;  //  native resolution of the guide head
-        int GYRes;  //  native resolution
-        int GSubX;  //  left side of the guide image subframe
-        int GSubY;  //  top of the guide image subframe
-        int GSubW;  //  Width of the guide image
-        int GSubH;  //  Height of the guide image
-        float GPixelSizex;  //  phyiscal size of the guider pixels
-        float GPixelSizey;
-        bool GuiderCompressed;
-
-        int FrameType;
-
-
-    private:
-    public:
+
+public:
+    CCDChip();
+    ~CCDChip();
+
+    typedef enum { LIGHT_FRAME=0, BIAS_FRAME, DARK_FRAME, FLAT_FRAME } CCD_FRAME;
+
+    int getXRes() { return XRes; }
+    int getYRes() { return YRes; }
+    int getSubX() { return SubX; }
+    int getSubY() { return SubY; }
+    int getSubW() { return SubW; }
+    int getSubH() { return SubH; }
+    int getBinX() { return BinX; }
+    int getBinY() { return BinY; }
+    int getPixelSizeX() { return PixelSizex; }
+    int getPixelSizeY() { return PixelSizey; }
+    int getBPP() { return BPP; }
+    int getFrameBufferSize() { return RawFrameSize; }
+    double getExposure() { return ImageExposureN[0].value; }
+    char *getFrameBuffer() { return RawFrame; }
+    bool isCompressed() { return SendCompressed; }
+    bool isInterlaced() { return Interlaced; }
+    CCD_FRAME getFrameType() { return FrameType; }
+
+    void setResolutoin(int x, int y);
+    void setFrame(int subx, int suby, int subw, int subh);
+    void setBin(int hor, int ver);
+    void setPixelSize(int x, int y);
+    void setCompressed (bool cmp);
+    void setInterlaced(bool intr);
+    void setFrameBufferSize(int nbuf);
+    void setBPP(int bpp);
+    int setFrameType(CCD_FRAME);
+    void setExposure(double duration);
+    void setExposureFailed();
+
+private:
+
+    int XRes;   //  native resolution of the ccd
+    int YRes;   //  ditto
+    int SubX;   //  left side of the subframe we are requesting
+    int SubY;   //  top of the subframe requested
+    int SubW;   //  width of the subframe
+    int SubH;   //  height of the subframe
+    int BinX;   //  Binning requested in the x direction
+    int BinY;   //  Binning requested in the Y direction
+    float PixelSizex;   //  pixel size in microns, x direction
+    float PixelSizey;   //  pixel size in microns, y direction
+    int BPP;            //  Bytes per Pixel
+    bool Interlaced;
+    char *RawFrame;
+    int RawFrameSize;
+    bool SendCompressed;
+    CCD_FRAME FrameType;
+
+    INumberVectorProperty *ImageExposureNP;
+    INumber ImageExposureN[1];
+
+    INumberVectorProperty *ImageFrameNP;
+    INumber ImageFrameN[4];
+
+    INumberVectorProperty *ImageBinNP;
+    INumber ImageBinN[2];
+
+    INumberVectorProperty *ImagePixelSizeNP;
+    INumber ImagePixelSizeN[6];
+
+    ISwitch FrameTypeS[4];
+    ISwitchVectorProperty *FrameTypeSP;
+
+    ISwitch CompressS[2];
+    ISwitchVectorProperty *CompressSP;
+
+    IBLOB FitsB;
+    IBLOBVectorProperty *FitsBP;
+
+    friend class INDI::CCD;
+};
+
+/**
+ * \class INDI::CCD
+   \brief Class to provide general functionality of CCD cameras with a single CCD sensor, or a primary CCD sensor in addition to a secondary CCD guide head.
+
+   It also implements the interface to perform guiding. The class enable the ability to \e snoop on telescope equatorial coordinates and record them in the
+   FITS file before upload. Developers need to subclass INDI::CCD to implement any driver for CCD cameras within INDI.
+
+\author Gerry Rozema, Jasem Mutlaq
+*/
+class INDI::CCD : public INDI::DefaultDriver, INDI::GuiderInterface
+{
+      public:
         CCD();
         virtual ~CCD();
 
-        //  A ccd needs to desribe the frame
-        //INumberVectorProperty CcdFrameNV;
-        //INumberVectorProperty CcdExposureNV;
-        //INumberVectorProperty CcdBinNV;
-        //INumberVectorProperty CcdPixelSizeNV;
-
-
-        INumberVectorProperty ImageFrameNV;
-        INumber ImageFrameN[4];
-
-        INumberVectorProperty ImageBinNV;
-        INumber ImageBinN[2];
-
-        INumberVectorProperty ImagePixelSizeNV;
-        INumber ImagePixelSizeN[6];
-
-        INumberVectorProperty ImageExposureNV;
-        INumber ImageExposureN[1];
-
-        //INumberVectorProperty ImageExposureReqNV;
-        //INumber ImageExposureReqN[1];
-
-        INumberVectorProperty GuiderFrameNV;
-        INumber GuiderFrameN[4];
-        INumberVectorProperty GuiderPixelSizeNV;
-        INumber GuiderPixelSizeN[6];
-        INumberVectorProperty GuiderExposureNV;
-        INumber GuiderExposureN[1];
-
-        ISwitch FrameTypeS[4];
-        ISwitchVectorProperty FrameTypeSV;
-
-
-        ISwitch CompressS[2];
-        ISwitchVectorProperty CompressSV;
-
-        ISwitch GuiderCompressS[2];
-        ISwitchVectorProperty GuiderCompressSV;
-
-
-        ISwitch GuiderVideoS[2];
-        ISwitchVectorProperty GuiderVideoSV;
-
-        INumber GuideNS[2];
-        INumberVectorProperty GuideNSV;
-        INumber GuideEW[2];
-        INumberVectorProperty GuideEWV;
-
-        IBLOB FitsB;
-        IBLOBVectorProperty FitsBV;
-
-        IBLOB GuiderB;
-        IBLOBVectorProperty GuiderBV;
-
-        virtual bool  initProperties();
+        virtual bool initProperties();
         virtual bool updateProperties();
         virtual void ISGetProperties (const char *dev);
-
         virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
         virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
-
-        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n) {return false;}
-
-
+        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
+        virtual void ISSnoopDevice (XMLEle *root);
+
+     protected:
+        /** \brief Start exposing primary CCD chip
+            \param duration Duration in seconds
+            \return 0 if OK and exposure will take some time to complete, 1 if exposure is short and complete already (e.g. bias), -1 on error.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+        */
         virtual int StartExposure(float duration);
+
+        /** \brief Uploads primary CCD exposed buffer as FITS to the client. Dervied classes should class this function when an exposure is complete.
+             \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+        */
         virtual bool ExposureComplete();
+
+        /** \brief Abort ongoing exposure
+            \return true is abort is successful, false otherwise.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+        */
+        virtual bool AbortExposure();
+
+        /** \brief Start exposing guide CCD chip
+            \param duration Duration in seconds
+            \return 0 if OK and exposure will take some time to complete, 1 if exposure is short and complete already (e.g. bias), -1 on error.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+        */
         virtual int StartGuideExposure(float duration);
+
+        /** \brief Abort ongoing exposure
+            \return true is abort is successful, false otherwise.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+        */
         virtual bool AbortGuideExposure();
+
+        /** \brief Uploads Guide head CCD exposed buffer as FITS to the client. Dervied classes should class this function when an exposure is complete.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+        */
         virtual bool GuideExposureComplete();
-        virtual int uploadfile(void *fitsdata,int total);
-        virtual int sendPreview();
-
-        //  Handy functions for child classes
-        virtual int SetCCDParams(int x,int y,int bpp,float xf,float yf);
-        virtual int SetGuidHeadParams(int x,int y,int bpp,float xf,float yf);
-
-        virtual int GuideNorth(float);
-        virtual int GuideSouth(float);
-        virtual int GuideEast(float);
-        virtual int GuideWest(float);
-
-        virtual int SetFrameType(int);
+
+        /** \brief INDI::CCD calls this function when CCD Frame dimension needs to be updated in the hardware. Derived classes should implement this function
+            \param x Subframe X coordinate in pixels.
+            \param y Subframe Y coordinate in pixels.
+            \param w Subframe width in pixels.
+            \param h Subframe height in pixels.
+            \note (0,0) is defined as most left, top pixel in the subframe.
+            \return true is CCD chip update is successful, false otherwise.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+        */
+        virtual bool updateCCDFrame(int x, int y, int w, int h);
+
+        /** \brief INDI::CCD calls this function when CCD Binning needs to be updated in the hardware. Derived classes should implement this function
+            \param hor Horizontal binning.
+            \param ver Vertical binning.
+            \return true is CCD chip update is successful, false otherwise.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+        */
+        virtual bool updateCCDBin(int hor, int ver);
+
+
+        /** \brief Setup CCD paramters for primary CCD. Child classes call this function to update CCD paramaters
+            \param x Frame X coordinates in pixels.
+            \param y Frame Y coordinates in pixels.
+            \param bpp Bits Per Pixels.
+            \param xf X pixel size in microns.
+            \param yf Y pixel size in microns.
+        */
+        virtual void SetCCDParams(int x,int y,int bpp,float xf,float yf);
+
+        /** \brief Setup CCD paramters for guide head CCD. Child classes call this function to update CCD paramaters
+            \param x Frame X coordinates in pixels.
+            \param y Frame Y coordinates in pixels.
+            \param bpp Bits Per Pixels.
+            \param xf X pixel size in microns.
+            \param yf Y pixel size in microns.
+        */
+        virtual void SetGuidHeadParams(int x,int y,int bpp,float xf,float yf);
+
+
+        /** \brief Guide northward for ms milliseconds
+            \param ms Duration in milliseconds.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+            \return True if successful, false otherwise.
+        */
+        virtual bool GuideNorth(float ms);
+
+        /** \brief Guide southward for ms milliseconds
+            \param ms Duration in milliseconds.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+            \return 0 if successful, -1 otherwise.
+        */
+        virtual bool GuideSouth(float ms);
+
+        /** \brief Guide easward for ms milliseconds
+            \param ms Duration in milliseconds.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+            \return 0 if successful, -1 otherwise.
+        */
+        virtual bool GuideEast(float ms);
+
+        /** \brief Guide westward for ms milliseconds
+            \param ms Duration in milliseconds.
+            \note This function is not implemented in INDI::CCD, it must be implemented in the child class
+            \return 0 if successful, -1 otherwise.
+        */
+        virtual bool GuideWest(float ms);
+
+        float RA;
+        float Dec;
+        bool HasGuideHead;
+        bool HasSt4Port;
+        bool InExposure;
+
+        CCDChip PrimaryCCD;
+        CCDChip GuideCCD;
+
+ private:
+    //  We are going to snoop these from a telescope
+    INumberVectorProperty EqNP;
+    INumber EqN[2];
+
+    ITextVectorProperty *TelescopeTP;
+    IText TelescopeT[1];
+
+    void addFITSKeywords(fitsfile *fptr);
+    int uploadfile(void *fitsdata,int total);
 
 };
Index: /BAORadio/libindi/libindi/libs/indibase/indidevice.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indidevice.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indidevice.cpp	(revision 642)
@@ -299,4 +299,5 @@
     //  We dont actually implement a device here
     //  So we cannot connect to it
+IDLog("IndiDevice Connect, we should never get here\n");
     IDMessage(deviceName(),"IndiDevice:: has no device attached....");
     return false;
